#include <stdio.h>
#include <stdlib.h> /*rand -hoz kell*/
#include <math.h>
#include <string.h>
#include <fcntl.h>
#define __MSDOS__ 1
#ifndef __MSDOS__
#include <sys/time.h> /*a veletlen-szam-generatort az idovel inicializalom */
#endif

#include <sys/types.h>
#include <sys/stat.h>

#define G 2.959122083e-04 /*Gauss-fele grav. allando negyzete*/
#define KI "/scratch/ribarik/gx%d.pgm"
#define BE "gx.in"
#define VIZSZ 640
#define FUGG 480
#define COL 255 /*0-tol meddig mennek a szinek*/
#define MAX_COLORS 256
#define N 1024 /* A probacsillagok szama osszesen a 2 galaxisra */
/* FIGYELEM: N-nek parosnak kell lennie!!! */
#define SAVSZ 2.0 
/* SAVSZ: Hany galaxissugarnyi szeles savban helyezze el a probacsillagokat */ 
#define LAPULTSAG 0.15 /* A galaxiskorongok lapultsaga */

#define SZORZOSZAM 2.0 
		       /* Szorzoszam a lepeskozhoz, ami biztosan jo: 1.0, de
                        * lehet egy picit novelni is... 
                        */
#define ENNYI_MEHET_KI 30 /* Hany probacsillag mehet ki a kepbol */

#define IDOLIMIT_SZORZOSZAM 11.0 /* ha az idolimit miatt akar kilepni */

#define TAVOLSAGLIMIT_SZORZOSZAM 12.0 /* ha a tavolsaglimit miatt akar kilepni */

#define FELBONTAS 20 /*hany kepet mentsen el*/


#define pow2(a,b) ((a)*(a))
#define pow3(a,b) ((a)*(a)*(a))


#ifdef __svr4__ 
#define GEP "Solaris"

#else

 #ifdef sparc

#define GEP "SunOS"
#define RAND_MAX 2147483000


 #endif

#endif


#ifdef linux

#define GEP "Linux"
static struct timezone  tz={0,DST_NONE};

#endif


#ifdef __MSDOS__

#define GEP "MSDOS"
#define KI "gx%d.pgm"

#endif


#ifndef GEP 

#define GEP "UNKNOWN MACHINE"

#endif


char** P;
char *szamok[256];
int hossz[256];
FILE *fb;
float kf[256];
float i11,j11,M1,R1,i22,j22,M2,R2,vinf,y00,ro;/*parameterek*/
double r1[3],r2[3],v1[3],v2[3],r0r[N],v0v[N],r1r[N],v1v[N],r2r[N],v2v[N];
/*mozgas leirasahoz*/ 
double skala;
void point(char**,int,int,int);
void line(char**,int,int,int,int,int);
void circle(char**,int,int,int,int,int);
void kepment(char**,int);
void clear(char**,int);




int main()
{
int p,i;

#ifdef __MSDOS__
   if ((fb = fopen(BE, "rt"))
       == NULL)
   {
      fprintf(stderr, "Nem tudom a %s file-t megnyitni.\n",BE);
      return 1;
   }
#endif   

printf("\n                gxx v0.0 for %s with picture saving support\n\n",GEP);
printf("    /Galaxis utkozteto program - irta: Ribarik Gabor (derivator) - 1995-96/ \n\n\n");

P = (char**)malloc(FUGG*sizeof(*P));
for (p =0;p < FUGG;p++) 
 if ((P[p] = (char*)malloc(VIZSZ*sizeof(*P[0])))==NULL)
  {
  printf("Malloc error a %d.-ik sornal\n",p);
  exit(1);
  }
for (p = 0;p < MAX_COLORS;p++) 
 {
 szamok[p] = malloc(10);
 sprintf(szamok[p],"%i ",p);
 hossz[p] = strlen(szamok[p]);
 }
printf("Malloc rendben\n");
 
adatbeolvasas();
kezdeti_ertek();
mozgas();


/*Ez a kep rajzolasat teszteli: line(P,0,0,639,479,255);
printf("Line 1\n");
line(P,0,479,639,0,255);
line(P,320,0,320,479,255);
line(P,0,240,639,240,255);  
circle(P,320,240,300,200,255);
for (p=0;p<200;p=p+20) circle(P,320,240,p,p,255);
printf("DRAW OK\n");
kepment(P);*/

for (p = 0;p < MAX_COLORS;p++) free(szamok[p]);
for (p = 0;p < FUGG;p++) free(P[p]);
free(P);
return 0;
}
void circle(tomb,x,y,a,b,c)  /*kozeppont,fel nagy- es kistengely,szin*/ 
char **tomb; 
int x,y,a,b,c;
{
float t,dt,aa,bb;
int xx,yy,mx,at,bt,ar,br;
t=0.0;
aa=(float) a;
bb=(float) b;
if (b<a) mx=a; else mx=b;
if (mx >= 20) dt=2.0/((float) mx); else dt=0.1;
for (t=0.0;t<=(2*(M_PI+dt));t=t+dt) 
    {at=x+(int) aa*cos(t); bt=y+(int) bb*sin(t);
     ar=x+(int) aa*cos(t+dt); br=y+(int) bb*sin(t+dt);
    line(tomb,at,bt,ar,br,c); 
    }
}
void line(tomb,xk,yk,xv,yv,c) /* kezdopont,vegpont,szin*/
char **tomb; 
int xk,yk,xv,yv,c;
{
int x,y,yy,ye,xkk,xvv,ykk,yvv;
float dx,dy;
if (xk<xv) {xkk=xk; xvv=xv; yvv=yv; ykk=yk;}
if (xk>xv) {xkk=xv; xvv=xk; yvv=yk; ykk=yv;}
dx=(float) (xvv-xkk); dy=(float) (yvv-ykk);
if (xv != xk) for (x=xkk;x<=xvv;++x)
  {y=ykk+(int) (dy*((float) (x-xkk))/dx); if (x==xkk) ye=y=ykk;
  if (x==xvv) y=yvv;
  /*if (yvv>ykk && y>yvv) y=yvv;
  if (yvv<ykk && y<yvv) y=yvv;
  if (yvv>ykk && y<ykk) y=ykk;
  if (yvv<ykk && y>ykk) y=ykk;*/
  if (y-ye>1) for (yy=ye;yy<=y;++yy) point(tomb,x,yy,c);
  else if (ye-y>1) for (yy=y;yy<=ye;++yy) point(tomb,x,yy,c);
       else point(tomb,x,y,c);
  ye=y;
  }
else if (yv>=yk) for (y=yk;y<=yv;++y) point(tomb,xk,y,c);
     else for (y=yv;y<=yk;++y) point(tomb,xk,y,c);  
}
void point(tomb,x,y,c) /* koordinatak,szin */
char **tomb; 
int x,y,c;
{
if ((x >=0) && (x < VIZSZ) && (y >= 0) && (y < FUGG)) tomb[y][x]=c;
}
void clear(tomb,c) /* a kepet egyszinure festi (torol) */
char **tomb; 
int c;
{
int i,j;
for (i=0;i<FUGG;++i) 
 {
 memset(tomb[i],0,VIZSZ*sizeof(*tomb[i]));
 }
}
#ifdef __MSDOS__
void kepment(char **tomb,int d) /*d: mi legyen a kep szama */
{
int i,j,k,l,slim;
char kiment[64];
FILE *fk; /*ezek file-ra vonatkozo mutatok*/

sprintf(kiment,KI,d); printf("Saving: "); printf(KI,d); printf("\n");

   if ((fk = fopen(kiment, "wt"))
       == NULL)
   {
      fprintf(stderr, "Nem tudom a %s file-t megnyitni.\n",kiment);
      return 1;
   }

if (COL<10) slim=34;
if (COL>=10 && COL<=99) slim=22;
if (COL>99) slim=17;
fprintf(fk,"P2\n");
fprintf(fk,"%d %d\n",VIZSZ,FUGG);
fprintf(fk,"%d\n",COL);
k=1;
for (j=FUGG-1;j>=0;--j)
    for (i=0;i<VIZSZ;++i)
        {   if ( P[j][i] != 0) {
                                fprintf(fk,"%d ",COL);
                               }
        
            else {
                 fprintf(fk,"%d ",0);
                 }
                if (k==slim) {putc('\n',fk); k=0;}
                    ++k;
                        }
                        fclose(fk);
                        }
                        
#else
void kepment(char **tomb,int d) /*d: mi legyen a kep szama */
{ 
int i,j,k,slim,len; 
char *s,*ss,kiment[64];
int fk; /*ezek file-ra vonatkozo mutatok*/ 
s = (char*)malloc(10*VIZSZ*FUGG);
sprintf(kiment,KI,d); printf("Saving: "); printf(KI,d); printf("\n");
fk=open(kiment,O_RDWR | O_CREAT,S_IREAD | S_IWRITE);
if (fk <0)
 {
 printf("Nem sikerult letrehozni a file-t!\n");
 return;
 }
if (COL<10) slim=34;
if (COL>=10 && COL<=99) slim=22;
if (COL>99) slim=17;
write(fk,"P2\n",3);
sprintf(s,"%d %d\n",VIZSZ,FUGG);
write(fk,s,strlen(s));
sprintf(s,"%d\n",COL);
write(fk,s,strlen(s));
k=0;
len=0;
ss=s;
for (j=FUGG-1;j>=0;--j)
    {
    char*p = tomb[j];
    for (i=0;i<VIZSZ;++i) 
     {
     int sz = p[i],h;
     memcpy(ss,szamok[sz],h = hossz[sz]);
     ss = s+(len+=h);
     if (k++==slim) {*(ss++)='\n';len++;k=0;}
     }
    } 
write(fk,s,len);
free(s); 
close(fk); 
}
#endif

adatbeolvasas()
{
float beolvas[256];
char s[256][64];
int i,j,k,c,comment;

#ifndef __MSDOS__
if((fb=fopen(BE,"r")) == NULL) 
    {
    printf("Nem tudom a %s file-t olvasasra megnyitni!\n",BE);
    exit(1);
    }
#endif

i=0; k=0;
while (fscanf(fb,"%s",&s[i]) != EOF) 
  {
comment=0;
for (j=0;j<64;++j) if(s[i][j]=='#') comment=1; 
if (comment==0) {sscanf(s[i],"%f",&beolvas[i]); kf[k]=beolvas[i]; ++k;}
   else while ((c=getc(fb)) != '\n') ; 
++i;
  }
fclose(fb); 
printf("Adatbeolvasas rendben\n");
}

kezdeti_ertek()
{

#ifdef linux

struct timeval time1;

#endif

int s,i;
double a,b,rs,th,h,V,rr[3],vv[3];

#ifdef linux

gettimeofday(&time1,&tz); srand(time1.tv_sec); /* inicializalas */

#endif

i11=kf[0]*M_PI/180.0;/*radian-ra atszamitas*/
j11=kf[1]*M_PI/180.0;
M1=kf[2];/*ez naptomegben van, nem kell atszamitani*/
R1=kf[3]*206264.8;/*CSE-re atszamitas*/
i22=kf[4]*M_PI/180.0;
j22=kf[5]*M_PI/180.0;
M2=kf[6];
R2=kf[7]*206264.8;
vinf=kf[8]*206264.8/365.2422;/*CSE/kozepnap-ra atszamitas*/
y00=kf[9]*206264.8;
ro=kf[10]*206264.8;/*ezek mar egi mechanikai egysegrendszerben vannak*/

/*
printf("i11: %e\nj11: %e\ni22: %e\nj22: %e\nM1: %e\n",i11,j11,i22,j22,M1); 
printf("M2: %e\nR1: %e\nR2: %e\ny00: %e\nvinf: %e\n",M2,R1,R2,y00,vinf);
printf("ro: %e\n",ro);*/ /*teszt*/


a=M2*y00/(M1+M2);
b=M2*ro/(M1+M2);
r1[0]=0.0; r1[1]=-a; r1[2]=-b;
r2[0]=0.0; r2[1]=y00-a; r2[2]=ro-b;
v1[0]=v1[1]=v1[2]=0.0;
v2[0]=v2[2]=0; v2[1]=-vinf;

/*for(s=0;s<3;++s) {
             printf("r1[%d]=%e\n",s,r1[s]); printf("r2[%d]=%e\n",s,r2[s]); 
             printf("v1[%d]=%e\n",s,v1[s]); printf("v2[%d]=%e\n",s,v2[s]);
                 }*/ /*teszt*/

printf("Galaxisok ertekadasa rendben\n");
for (i=0;i<N/2;++i) 
 {
 rs=R1*(1.0+SAVSZ*rand()/(float) RAND_MAX); 
 th=2.0*M_PI*rand()/(float) RAND_MAX;
 h=R1*LAPULTSAG*(-0.5+rand()/(float) RAND_MAX);

 V=sqrt(G*M1/sqrt(rs*rs+h*h));
 rr[0]=rs*cos(th); rr[1]=rs*sin(th); rr[2]=h;
 vv[0]=-V*sin(th); vv[1]=V*cos(th); vv[2]=0;
 r0r[i]=r1[0]+cos(j11)*rr[0]+sin(j11)*rr[2];
 r1r[i]=r1[1]-sin(j11)*sin(i11)*rr[0]+cos(i11)*rr[1]+cos(j11)*sin(i11)*rr[2];
 r2r[i]=r1[2]-sin(j11)*cos(i11)*rr[0]-sin(i11)*rr[1]+cos(j11)*cos(i11)*rr[2];

 v0v[i]=v1[0]+cos(j11)*vv[0]+sin(j11)*vv[2];
 v1v[i]=v1[1]-sin(j11)*sin(i11)*vv[0]+cos(i11)*vv[1]+cos(j11)*sin(i11)*vv[2];
 v2v[i]=v1[2]-sin(j11)*cos(i11)*vv[0]-sin(i11)*vv[1]+cos(j11)*cos(i11)*vv[2];
 }

for (i=N/2;i<N;++i)
 {
 rs=R2*(1.0+SAVSZ*rand()/(float) RAND_MAX);
 th=2.0*M_PI*rand()/(float) RAND_MAX;
 h=R2*LAPULTSAG*(-0.5+rand()/(float) RAND_MAX);

 V=sqrt(G*M2/sqrt(rs*rs+h*h));

 rr[0]=rs*cos(th); rr[1]=rs*sin(th); rr[2]=h;
 vv[0]=-V*sin(th); vv[1]=V*cos(th); vv[2]=0.0;

 r0r[i]=r2[0]+cos(j22)*rr[0]+sin(j22)*rr[2];
 r1r[i]=r2[1]-sin(j22)*sin(i22)*rr[0]+cos(i22)*rr[1]+cos(j22)*sin(i22)*rr[2];
 r2r[i]=r2[2]-sin(j22)*cos(i22)*rr[0]-sin(i22)*rr[1]+cos(j22)*cos(i22)*rr[2];

 v0v[i]=v2[0]+cos(j22)*vv[0]+sin(j22)*vv[2];
 v1v[i]=v2[1]-sin(j22)*sin(i22)*vv[0]+cos(i22)*vv[1]+cos(j22)*sin(i22)*vv[2];
 v2v[i]=v2[2]-sin(j22)*cos(i22)*vv[0]-sin(i22)*vv[1]+cos(j22)*cos(i22)*vv[2];
 }
printf("Probacsillagok ertekadasa rendben\n");
}
vetites()
{
int k,x,y,l,m,ki,kiakarmenni;
double i,j,xv,yv,th,X0,Y0,Z0,xe,ye,c,tmp,uj_skala[ENNYI_MEHET_KI];

ki=ENNYI_MEHET_KI;
kiakarmenni=0;

i=(i11+i22)/2.0; j=(j11+j22)/2.0;
     for (k=0;k<ki;++k) uj_skala[k]=0.0;
/*printf("Kimehet: %d csillag.\n",ki);*/
printf("Skalaszamitast kezdem!\n"); 
/*printf("A pillanatnyi skala:%f .!\n",skala);*/ 
     for (k=0;k<N;++k)
       {
       c=cos(i)*r1r[k]-sin(i)*r2r[k];
       c=sqrt((c*c)); 
       tmp=(cos(j)*r0r[k]-sin(i)*sin(j)*r1r[k]-sin(j)*cos(i)*r2r[k]);
       tmp=(VIZSZ/FUGG)*sqrt((tmp*tmp));
       if(tmp>c) c=tmp;
       /*printf("c: %f\n",c);*/
       
      if (c>skala) { 
                     for(l=ki-1 ; (l>0) && (uj_skala[l]>=c) ; --l) ;
                     for(m=0 ; m<l ; ++m) uj_skala[m]=uj_skala[m+1];
                     uj_skala[l]=c;                     
                     ++kiakarmenni;
                    } 
       }
if (skala==0.0) {skala=1.25*uj_skala[ki-1]; kiakarmenni=0; printf("Mivel a skala=0.0, uj skala van, megpedig:%f!\n",skala);}
if (kiakarmenni>ki)
     {
     if(skala) printf("A skalan modositani kellett, mert igy nem fert volna ki a rajz!\n");
     skala=1.25*uj_skala[0];
     }
printf("Skalaszamitast befejeztem!\n");     
for (k=0;k<N;++k)
 {
xv=cos(j)*r0r[k]-sin(i)*sin(j)*r1r[k]-sin(j)*cos(i)*r2r[k];
yv=cos(i)*r1r[k]-sin(i)*r2r[k];
x=(int) VIZSZ*0.5*(1.0+yv/skala); y=(int) (FUGG/2+VIZSZ*0.5*xv/skala);
point(P,x,y,255);
 }
for (th=0.0;th<=2*M_PI;th+=M_PI/60.0) /* korong rajzolasa */
 {
 X0=r1[0]+cos(j11)*cos(th)*R1;
 Y0=r1[1]-sin(j11)*sin(i11)*cos(th)*R1+cos(i11)*sin(th)*R1;
 Z0=r1[2]-sin(j11)*cos(i11)*cos(th)*R1-sin(i11)*sin(th)*R1;
 xv=cos(j)*X0-sin(i)*sin(j)*Y0-sin(j)*cos(i)*Z0;
 yv=cos(i)*Y0-sin(i)*Z0;
 yv=(int) VIZSZ*0.5*(1.0+yv/skala); xv=(int) (FUGG/2+VIZSZ*0.5*xv/skala);
 if (th!=0.0) line(P,ye,xe,yv,xv,255); 
 xe=xv; ye=yv;
 }
for (th=0.0;th<=2*M_PI;th+=M_PI/60.0)
 {
 X0=r2[0]+cos(j22)*cos(th)*R2;
 Y0=r2[1]-sin(j22)*sin(i22)*cos(th)*R2+cos(i22)*sin(th)*R2;
 Z0=r2[2]-sin(j22)*cos(i22)*cos(th)*R2-sin(i22)*sin(th)*R2;
 xv=cos(j)*X0-sin(i)*sin(j)*Y0-sin(j)*cos(i)*Z0;
 yv=cos(i)*Y0-sin(i)*Z0;
 yv=(int) VIZSZ*0.5*(1.0+yv/skala); xv=(int) (FUGG/2+VIZSZ*0.5*xv/skala);
 if (th!=0.0) line(P,ye,xe,yv,xv,255);
 xe=xv; ye=yv;
 }
}

mozgas()
{
int i,k,kepszam;
double TMAX,a1[3],a2[3],a0ai,a1ai,a2ai,r12abs,ri1,ri2,sz,t,DT,VP,vs,ms;
sz=0.0; kepszam=0; skala=0.0;
TMAX=3.0*y00/vinf;
printf("Legfeljebb %e evig szamitom a mozgast!\n",TMAX/365.24);
for (t=0.0;sz<4*y00*y00*TAVOLSAGLIMIT_SZORZOSZAM && t<TMAX*IDOLIMIT_SZORZOSZAM;t+=DT)
{
sz=pow2(r1[0],2.0)+pow2(r1[1],2.0)+pow2(r1[2],2.0)+pow2(r2[0],2.0)+pow2(r2[1],2.0);
sz+=pow2(r2[2],2.0);
vs=sqrt(G*M2/R2); if(sqrt(G*M2/R2)<sqrt(G*M2/R2)) vs=sqrt(G*M2/R2);
ms=R1; if(R1>R2) ms=R2;
DT=ms*SZORZOSZAM*9e-03/vs; 
if (t>=TMAX*kepszam/FELBONTAS)
 {
 clear(P,0);
 printf("Ido: %e ev:\n",t/365.24);
 if (kepszam==0) printf("Az aktualis lepeskoz: %e kozepnap.\n",DT);
/* if (kepszam==0) printf("sqrt(G*M2/R2): %e\n",sqrt(G*M2/R2));*/
 vetites();
 kepment(P,kepszam);
 ++kepszam;
 }
if (t==0.0) printf("Mozgas indul!\n");
r12abs=sqrt(pow2(r1[0]-r2[0],2.0)+pow2(r1[1]-r2[1],2.0)+pow2(r1[2]-r2[2],2.0));
/*
printf("1. ciklus indul!\n");
*/
for (k=0;k<3;++k) {a1[k]=G*M2*(r2[k]-r1[k])/pow3(r12abs,3.0); 
                   a2[k]=G*M1*(r1[k]-r2[k])/pow3(r12abs,3.0);
                   r1[k]=r1[k]+v1[k]*DT+a1[k]*DT*DT/2;
                   r2[k]=r2[k]+v2[k]*DT+a2[k]*DT*DT/2;
                   v1[k]=v1[k]+a1[k]*DT;
                   v2[k]=v2[k]+a2[k]*DT;
                  }
/*
printf("2. ciklus indul!\n");
*/
for (i=0;i<N;++i)
{
/*
printf("A ciklusindex: %d\n",i);
*/
ri1=sqrt(pow2(r1[0]-r0r[i],2.0)+pow2(r1[1]-r1r[i],2.0)+pow2(r1[2]-r2r[i],2.0));
ri2=sqrt(pow2(r2[0]-r0r[i],2.0)+pow2(r2[1]-r1r[i],2.0)+pow2(r2[2]-r2r[i],2.0));
/*
printf("ri1: %f\n",ri1);
printf("ri2: %f\n",ri2);
*/
a0ai=G*M1*(r1[0]-r0r[i])/pow3(ri1,3.0)+G*M2*(r2[0]-r0r[i])/pow3(ri2,3.0);
a1ai=G*M1*(r1[1]-r1r[i])/pow3(ri1,3.0)+G*M2*(r2[1]-r1r[i])/pow3(ri2,3.0);
a2ai=G*M1*(r1[2]-r2r[i])/pow3(ri1,3.0)+G*M2*(r2[2]-r2r[i])/pow3(ri2,3.0);

/*
printf("a0a: %f\n",a0ai);
printf("a1a: %f\n",a1ai);
printf("a2a: %f\n",a2ai);

printf("Gyorsulasok rendben!\n");                   
*/
r0r[i]=r0r[i]+v0v[i]*DT+a0ai*DT*DT/2;
r1r[i]=r1r[i]+v1v[i]*DT+a1ai*DT*DT/2;
r2r[i]=r2r[i]+v2v[i]*DT+a2ai*DT*DT/2;
/*
printf("UJ helyek rendben!\n");                   

printf("r0r: %f\n",r0r[i]);
printf("r1r: %f\n",r1r[i]);
printf("r2r: %f\n",r2r[i]);
*/

v0v[i]=v0v[i]+a0ai*DT;
v1v[i]=v1v[i]+a1ai*DT;
v2v[i]=v2v[i]+a2ai*DT;

/*
printf("v0v: %f\n",v0v[i]);
printf("v1v: %f\n",v1v[i]);
printf("v2v: %f\n",v2v[i]);

printf("UJ sebessegek rendben!\n");                   
*/
                  }
}
if (sz>=2*y00*y00) 
printf("A kilepes oka: a gx-ok nagyon messze eltavolodtak egymastol.\n");
else if (t>=TMAX) printf("A kilepes oka: a szamolasi idot tullepte.\n");
else printf("A kilepes oka: nem tudom.\n");
}
