/*
 * gxx.c - This file is part of the gx package for Linux, SunOS & Solaris,
 * written by Gabor Ribarik <ribarik@innin.elte.hu>.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#include <stdio.h>
#include <stdlib.h> /*rand -hoz kell*/
#include <math.h>
#include <string.h>
#include <fcntl.h>
#include <sys/time.h> /*a veletlen-szam-generatort az idovel inicializalom */ 
#include <sys/types.h> 
#include <sys/stat.h>
#include <pwd.h>
#include <unistd.h>
#include <X11/Xlib.h>


#define G 2.959122083e-04 /*Gauss-fele grav. allando negyzete*/
#define pow2(a,b) ((a)*(a))
#define pow3(a,b) ((a)*(a)*(a))
#define mod(a,b) (a)-(b)*((a)/(b))

#include "config.h"

#ifdef __svr4__ 
#define GEP "Solaris"

#else

 #ifdef sparc

#define GEP "SunOS"
#define RAND_MAX 2147483000


 #endif

#endif  


#ifdef linux

#define GEP "Linux"

#endif

#ifndef __svr4__

static struct timezone  tz={0,DST_NONE};


#endif  



unsigned char P[(VIZSZ*FUGG)/8+1];
char *szamok[256];
int hossz[256];
int ki;
float kf[256];
float i11,j11,M1,R1,i22,j22,M2,R2,vinf,y00,ro;/*parameterek*/
double r1[3],r2[3],v1[3],v2[3],r0r[N],v0v[N],r1r[N],v1v[N],r2r[N],v2v[N];
/*mozgas leirasahoz*/ 
double skala;
int FELBONTAS;
void point(int,int,int);
void line(int,int,int,int,int);
void kepment(int);
int kirajzol(int);
void clear(int);
unsigned char getbit(unsigned char,unsigned char);
unsigned char bittukrozes(unsigned char);

extern Display *theDisplay;
GC theGC;
Window theWindow;
int save;

int main(int argc, char *argv[])
{
int p,i;


printf("\n                       gxx v1.4 for %s with X support\n\n",GEP);
printf("    /Galaxis utkozteto program - irta: Ribarik Gabor (derivator) - 1995-96/ \n\n\n");

ki=(int) N*KIMEHET;
save=0;
if ( argc == 2 && strcmp(argv[1],"-s") == 0 ) {save=1; FELBONTAS=20;}
else FELBONTAS=100;

printf("Hasznalata: A gx.in file-ban lehet a kezdeti ertekeket beallitani,\n");
printf("'gxx'-el inditva X-s ablakba rajzol, 'gxx -s'-el inditva pedig\n");
printf("/scratch/${USERNAME}/gx<>.pbm neven kepeket ment el (30-at).\n");
printf("Kilepes: 'CTRL-C' (terminalon), vagy 'q' az X-s ablakban.\n\n");

adatbeolvasas();
kezdeti_ertek();

mozgas();

return 0;
}
void line(xk,yk,xv,yv,c) /* kezdopont,vegpont,szin*/
int xk,yk,xv,yv,c;
{
int x,y,yy,ye,xkk,xvv,ykk,yvv;
float dx,dy;
if (xk<xv) {xkk=xk; xvv=xv; yvv=yv; ykk=yk;}
if (xk>xv) {xkk=xv; xvv=xk; yvv=yk; ykk=yv;}
dx=(float) (xvv-xkk); dy=(float) (yvv-ykk);
if (xv != xk) for (x=xkk;x<=xvv;++x)
  {y=ykk+(int) (dy*((float) (x-xkk))/dx); if (x==xkk) ye=y=ykk;
  if (x==xvv) y=yvv;
  /*if (yvv>ykk && y>yvv) y=yvv;
  if (yvv<ykk && y<yvv) y=yvv;
  if (yvv>ykk && y<ykk) y=ykk;
  if (yvv<ykk && y>ykk) y=ykk;*/
  if (y-ye>1) for (yy=ye;yy<=y;++yy) point(x,yy,c);
  else if (ye-y>1) for (yy=y;yy<=ye;++yy) point(x,yy,c);
       else point(x,y,c);
  ye=y;
  }
else if (yv>=yk) for (y=yk;y<=yv;++y) point(xk,y,c);
     else for (y=yv;y<=yk;++y) point(xk,y,c);  
}

void point(x,y,c) /* koordinatak,szin */
int x,y,c;
{
int k;
k=y*VIZSZ+x;
if ((x >=0) && (x < VIZSZ) && (y >= 0) && (y < FUGG)) 
  {
/*  P[k/8]|=power(2,7-mod(k,8));*//*Talan ez gyorsabb...*/
  P[k/8]|=bittukrozes(power(2,mod(k,8)));
  }
}

void clear(c) /* a kepet egyszinure festi (torol) */
int c;
{
int i;
for (i=0;i<((VIZSZ*FUGG)/8+1);++i) 
 {
 P[i]=00;
 }
}

void kepment(int d) /*d: mi legyen a kep szama */
{
int i,j,k,l,m,slim;
char kiment[64];
char username[25],sy[30];
struct passwd *pass;
uid_t uid;
FILE *fk; /*ezek file-ra vonatkozo mutatok*/

uid = getuid();
pass=getpwuid(uid);
sprintf(username,"%s",pass->pw_name);

sprintf(kiment,KI,username,d); printf("Saving: "); printf(KI,username,d); printf
("\n");

   if ((fk = fopen(kiment, "w"))
          == NULL)
             {
                   fprintf(stderr, "Nem tudom a %s file-t megnyitni.\n",kiment);
                         return ;
                            }
                            
                            if (COL<10) slim=34;
                            if (COL>=10 && COL<=99) slim=22;
                            if (COL>99) slim=17;
                            #ifdef USE_RAW_PBM
                            fprintf(fk,"P4\n");
                            #else
                            fprintf(fk,"P2\n");
                            #endif
                            fprintf(fk,"%d %d\n",VIZSZ,FUGG);
                            #ifndef USE_RAW_PBM
                            fprintf(fk,"%d\n",COL);
                            #endif
                            k=1;

#ifdef USE_RAW_PBM
for (j=0;j<(VIZSZ*FUGG)/8+1;++j) putc(~P[j],fk);
#else
for (j=FUGG-1;j>=0;--j)
    for (i=0;i<VIZSZ;++i){
            m=j*VIZSZ+i;
            if ( getbit(P[m/8],mod(m,8)) != 00) fprintf(fk,"%d ",COL);
            else fprintf(fk,"%d ",0);
if (k==slim) {putc('\n',fk); k=0;}
++k;
}
#endif

fclose(fk);      

#ifndef USE_RAW_PBM                                                         
sprintf(sy,"gzip -9 /scratch/%s/*.pgm",username);
system(sy);
#endif

}              

adatbeolvasas()
{
float beolvas[256];
char s[256][256];
int i,j,k,c,comment;
FILE *fopen(),*fb;
fb=fopen(BE,"r");
i=0; k=0;
while (fscanf(fb,"%s",&s[i]) != EOF) 
  {
comment=0;
for (j=0;j<256;++j) if(s[i][j]=='#') comment=1; 
if (comment==0) {sscanf(s[i],"%f",&beolvas[i]); kf[k]=beolvas[i]; ++k;}
   else while ((c=getc(fb)) != '\n') ; 
++i;
  }
fclose(fb); 
printf("Adatbeolvasas rendben.\n");
}

kezdeti_ertek()
{

#ifndef __svr4__

struct timeval time1;

#endif

int s,i;
double a,b,rs,th,h,V,rr[3],vv[3];

#ifndef __svr4__

gettimeofday(&time1,&tz); srand(time1.tv_sec); /* inicializalas */

#endif

i11=kf[0]*M_PI/180.0;/*radian-ra atszamitas*/
j11=kf[1]*M_PI/180.0;
M1=kf[2];/*ez naptomegben van, nem kell atszamitani*/
R1=kf[3]*206264.8;/*CSE-re atszamitas*/
i22=kf[4]*M_PI/180.0;
j22=kf[5]*M_PI/180.0;
M2=kf[6];
R2=kf[7]*206264.8;
vinf=kf[8]*206264.8/365.2422;/*CSE/kozepnap-ra atszamitas*/
y00=kf[9]*206264.8;
ro=kf[10]*206264.8;/*ezek mar egi mechanikai egysegrendszerben vannak*/

a=M2*y00/(M1+M2);
b=M2*ro/(M1+M2);
r1[0]=0.0; r1[1]=-a; r1[2]=-b;
r2[0]=0.0; r2[1]=y00-a; r2[2]=ro-b;
v1[0]=v1[1]=v1[2]=0.0;
v2[0]=v2[2]=0; v2[1]=-vinf;

/*for(s=0;s<3;++s) {
             printf("r1[%d]=%e\n",s,r1[s]); printf("r2[%d]=%e\n",s,r2[s]); 
             printf("v1[%d]=%e\n",s,v1[s]); printf("v2[%d]=%e\n",s,v2[s]);
                 }*/ /*teszt*/

printf("Galaxisok ertekadasa rendben.\n");
for (i=0;i<N/2;++i) 
 {
 rs=R1*(1.0+SAVSZ*rand()/(float) RAND_MAX); 
 th=2.0*M_PI*rand()/(float) RAND_MAX;
 h=R1*LAPULTSAG*(-0.5+rand()/(float) RAND_MAX);

 V=sqrt(G*M1/sqrt(rs*rs+h*h));
 rr[0]=rs*cos(th); rr[1]=rs*sin(th); rr[2]=h;
 vv[0]=-V*sin(th); vv[1]=V*cos(th); vv[2]=0;
 r0r[i]=r1[0]+cos(j11)*rr[0]+sin(j11)*rr[2];
 r1r[i]=r1[1]-sin(j11)*sin(i11)*rr[0]+cos(i11)*rr[1]+cos(j11)*sin(i11)*rr[2];
 r2r[i]=r1[2]-sin(j11)*cos(i11)*rr[0]-sin(i11)*rr[1]+cos(j11)*cos(i11)*rr[2];

 v0v[i]=v1[0]+cos(j11)*vv[0]+sin(j11)*vv[2];
 v1v[i]=v1[1]-sin(j11)*sin(i11)*vv[0]+cos(i11)*vv[1]+cos(j11)*sin(i11)*vv[2];
 v2v[i]=v1[2]-sin(j11)*cos(i11)*vv[0]-sin(i11)*vv[1]+cos(j11)*cos(i11)*vv[2];
 }

for (i=N/2;i<N;++i)
 {
 rs=R2*(1.0+SAVSZ*rand()/(float) RAND_MAX);
 th=2.0*M_PI*rand()/(float) RAND_MAX;
 h=R2*LAPULTSAG*(-0.5+rand()/(float) RAND_MAX);

 V=sqrt(G*M2/sqrt(rs*rs+h*h));

 rr[0]=rs*cos(th); rr[1]=rs*sin(th); rr[2]=h;
 vv[0]=-V*sin(th); vv[1]=V*cos(th); vv[2]=0.0;

 r0r[i]=r2[0]+cos(j22)*rr[0]+sin(j22)*rr[2];
 r1r[i]=r2[1]-sin(j22)*sin(i22)*rr[0]+cos(i22)*rr[1]+cos(j22)*sin(i22)*rr[2];
 r2r[i]=r2[2]-sin(j22)*cos(i22)*rr[0]-sin(i22)*rr[1]+cos(j22)*cos(i22)*rr[2];

 v0v[i]=v2[0]+cos(j22)*vv[0]+sin(j22)*vv[2];
 v1v[i]=v2[1]-sin(j22)*sin(i22)*vv[0]+cos(i22)*vv[1]+cos(j22)*sin(i22)*vv[2];
 v2v[i]=v2[2]-sin(j22)*cos(i22)*vv[0]-sin(i22)*vv[1]+cos(j22)*cos(i22)*vv[2];
 }
printf("Probacsillagok ertekadasa rendben.\n");
}
vetites()
{
int k,x,y,l,m,kiakarmenni;
double i,j,xv,yv,th,X0,Y0,Z0,xe,ye,c,tmp,uj_skala[ki];

kiakarmenni=0;

i=(i11+i22)/2.0; j=(j11+j22)/2.0;
     for (k=0;k<ki;++k) uj_skala[k]=0.0;
     for (k=0;k<N;++k)
       {
       c=cos(i)*r1r[k]-sin(i)*r2r[k];
       c=sqrt((c*c)); 
       tmp=(cos(j)*r0r[k]-sin(i)*sin(j)*r1r[k]-sin(j)*cos(i)*r2r[k]);
       tmp=(VIZSZ/FUGG)*sqrt((tmp*tmp));
       if(tmp>c) c=tmp;
       /*printf("c: %f\n",c);*/
       
      if (c>skala) { 
                     for(l=ki-1 ; (l>0) && (uj_skala[l]>=c) ; --l) ;
                     for(m=0 ; m<l ; ++m) uj_skala[m]=uj_skala[m+1];
                     uj_skala[l]=c;                     
                     ++kiakarmenni;
                    } 
       }
if (skala==0.0) {skala=1.25*uj_skala[ki-1]; kiakarmenni=0; }
if (kiakarmenni>ki)
     {
     if(skala) printf("A skalan modositani kellett, mert igy nem fert volna ki a rajz!\n");
     skala=1.25*uj_skala[0];
     }
for (k=0;k<N;++k)
 {
xv=cos(j)*r0r[k]-sin(i)*sin(j)*r1r[k]-sin(j)*cos(i)*r2r[k];
yv=cos(i)*r1r[k]-sin(i)*r2r[k];
x=(int) VIZSZ*0.5*(1.0+yv/skala); y=(int) (FUGG/2+VIZSZ*0.5*xv/skala);
point(x,y,255);
 }
for (th=0.0;th<=2*M_PI;th+=M_PI/60.0) /* korong rajzolasa */
 {
 X0=r1[0]+cos(j11)*cos(th)*R1;
 Y0=r1[1]-sin(j11)*sin(i11)*cos(th)*R1+cos(i11)*sin(th)*R1;
 Z0=r1[2]-sin(j11)*cos(i11)*cos(th)*R1-sin(i11)*sin(th)*R1;
 xv=cos(j)*X0-sin(i)*sin(j)*Y0-sin(j)*cos(i)*Z0;
 yv=cos(i)*Y0-sin(i)*Z0;
 yv=(int) VIZSZ*0.5*(1.0+yv/skala); xv=(int) (FUGG/2+VIZSZ*0.5*xv/skala);
 if (th!=0.0) line(ye,xe,yv,xv,255); 
 xe=xv; ye=yv;
 }
for (th=0.0;th<=2*M_PI;th+=M_PI/60.0)
 {
 X0=r2[0]+cos(j22)*cos(th)*R2;
 Y0=r2[1]-sin(j22)*sin(i22)*cos(th)*R2+cos(i22)*sin(th)*R2;
 Z0=r2[2]-sin(j22)*cos(i22)*cos(th)*R2-sin(i22)*sin(th)*R2;
 xv=cos(j)*X0-sin(i)*sin(j)*Y0-sin(j)*cos(i)*Z0;
 yv=cos(i)*Y0-sin(i)*Z0;
 yv=(int) VIZSZ*0.5*(1.0+yv/skala); xv=(int) (FUGG/2+VIZSZ*0.5*xv/skala);
 if (th!=0.0) line(ye,xe,yv,xv,255);
 xe=xv; ye=yv;
 }
}
mozgas()
{
int i,k,kepszam;
double TMAX,a1[3],a2[3],a0a,a1a,a2a,r12abs,ri1,ri2,sz,t,DT,VP,vs,ms;
sz=0.0; kepszam=0; skala=0.0;
TMAX=3.0*y00/vinf;
printf("Legfeljebb %e evig szamitom a mozgast!\n",TMAX/365.24);
for (t=0.0;sz<4*y00*y00*TAVOLSAGLIMIT_SZORZOSZAM && t<TMAX*IDOLIMIT_SZORZOSZAM;t+=DT)
{
sz=pow2(r1[0],2.0)+pow2(r1[1],2.0)+pow2(r1[2],2.0)+pow2(r2[0],2.0)+pow2(r2[1],2.0);
sz+=pow2(r2[2],2.0);
vs=sqrt(G*M2/R2); if(sqrt(G*M2/R2)<sqrt(G*M2/R2)) vs=sqrt(G*M2/R2);
ms=R1; if(R1>R2) ms=R2;
DT=ms*SZORZOSZAM*9e-03/vs; 
if (t>=TMAX*kepszam/FELBONTAS)
 {
 clear(0);
 printf("Ido: %e ev:\n",t/365.24);
 if (kepszam==0) printf("Az aktualis lepeskoz: %e kozepnap.\n",DT);
/* if (kepszam==0) printf("sqrt(G*M2/R2): %e\n",sqrt(G*M2/R2));*/
 vetites();
 if (save)
 kepment(kepszam);
 else kirajzol(kepszam);
 ++kepszam;
 }
if (t==0.0) printf("Mozgas indul!\n");
r12abs=sqrt(pow2(r1[0]-r2[0],2.0)+pow2(r1[1]-r2[1],2.0)+pow2(r1[2]-r2[2],2.0));
for (k=0;k<3;++k) {a1[k]=G*M2*(r2[k]-r1[k])/pow3(r12abs,3.0); 
                   a2[k]=G*M1*(r1[k]-r2[k])/pow3(r12abs,3.0);
                   r1[k]=r1[k]+v1[k]*DT+a1[k]*DT*DT/2;
                   r2[k]=r2[k]+v2[k]*DT+a2[k]*DT*DT/2;
                   v1[k]=v1[k]+a1[k]*DT;
                   v2[k]=v2[k]+a2[k]*DT;
                  }
for (i=0;i<N;++i) {
ri1=sqrt(pow2(r1[0]-r0r[i],2.0)+pow2(r1[1]-r1r[i],2.0)+pow2(r1[2]-r2r[i],2.0));
ri2=sqrt(pow2(r2[0]-r0r[i],2.0)+pow2(r2[1]-r1r[i],2.0)+pow2(r2[2]-r2r[i],2.0));

a0a=G*M1*(r1[0]-r0r[i])/pow3(ri1,3.0)+G*M2*(r2[0]-r0r[i])/pow3(ri2,3.0);
a1a=G*M1*(r1[1]-r1r[i])/pow3(ri1,3.0)+G*M2*(r2[1]-r1r[i])/pow3(ri2,3.0);
a2a=G*M1*(r1[2]-r2r[i])/pow3(ri1,3.0)+G*M2*(r2[2]-r2r[i])/pow3(ri2,3.0);
                   
r0r[i]=r0r[i]+v0v[i]*DT+a0a*DT*DT/2;
r1r[i]=r1r[i]+v1v[i]*DT+a1a*DT*DT/2;
r2r[i]=r2r[i]+v2v[i]*DT+a2a*DT*DT/2;

v0v[i]=v0v[i]+a0a*DT;
v1v[i]=v1v[i]+a1a*DT;
v2v[i]=v2v[i]+a2a*DT;
                  }
}
if (sz>=4*TAVOLSAGLIMIT_SZORZOSZAM*y00*y00) 
printf("A kilepes oka: a gx-ok nagyon messze eltavolodtak egymastol.\n");
else if (t>=TMAX*IDOLIMIT_SZORZOSZAM) printf("A kilepes oka: a szamolasi idot tullepte.\n");
else printf("A kilepes oka: nem tudom.\n");
}

unsigned char getbit(unsigned char c,unsigned char p)
{
/*
return (c<<p)&128;
*/
return c&(power(2,7-p));
}

unsigned char bittukrozes(unsigned char x)
{
unsigned char tmp,y=00;
for (tmp=0;tmp<8;++tmp) if (getbit(x,tmp)!=00) y+=power(2,tmp);
return y;
}

power(alap,kitevo)
unsigned char alap;
unsigned char kitevo;
{
int tmp;
unsigned char szam=1;
for (tmp=0;tmp<kitevo;++tmp) szam*=alap;
return szam;
}


int kirajzol(int d)
{
int x,y,m,quit;
XEvent e; 
Window openWindow();
XGCValues v;

if (d==0)
{
printf("\nTrying to connect the X-server...\n\n");
if(initX()) /*kapcsolat*/
printf("O.K.\n");
getXInfo();
printf("\n\n");
/*Ablak nyitasa:*/
theWindow=openWindow( 0,0,/*x,y*/
                      VIZSZ,FUGG,/*width,height*/
                      0,
                      &theGC);     /*This is NOT a pop-up*/
XStoreName(theDisplay, theWindow, "gx -- Galaxis utkoztetes (derivator software - 1995-96)");
                       
}

XClearWindow(theDisplay, theWindow);

/* Most torlom a GC-t*/
/*
v.plane_mask=GXset;
XChangeGC(theDisplay,theGC,GXset, &v);
*/
/* XFlush nem kell */
XFlush( theDisplay );
/*sleep(1);*/

for (x=0;x<VIZSZ;++x)
    for (y=0;y<FUGG;++y)
        {  
            m=y*VIZSZ+x;
            if (getbit(P[m/8],mod(m,8)) != 00) XDrawPoint(theDisplay,theWindow,theGC,x,y);
        }
    XFlush( theDisplay );

if( XEventsQueued(theDisplay,QueuedAfterReading) )
/*Ez megvizsgalja, hogy van-e Event, ugyanis az XNextEvent addig var,*/
/*ameddig nem jon egy, es azt nem szeretnem...*/
{
 XNextEvent(theDisplay,&e);
   if (((XKeyEvent*)(&e))->keycode==XKeysymToKeycode(theDisplay,XStringToKeysym("q")))
    {
    printf("Goodbye!\n\n");
    XDestroyWindow(theDisplay,theWindow);
    quitX();
    exit(1);
    }
}


return 0;
}