/*
 * windowx.c - This file is part of the gx package for Linux, SunOS & Solaris,
 * written by Gabor Ribarik <ribarik@innin.elte.hu>.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
extern Display *theDisplay;
extern int theScreen;
extern int theDepth;/*szinek szama*/
unsigned long theBlackPixel;
unsigned long theWhitePixel;
#define BORDER_WIDTH 2

Window openWindow(x,y,width,height,flag,theNewGC)
int x,y,width,height,flag;/*if flag>0 the window is a pop-up*/
GC *theNewGC;
{
XSetWindowAttributes theWindowAttributes;
XSizeHints           theSizeHints;
unsigned long        theWindowMask;
/* unsigned long myforeground,mybackground;*/
Window               theNewWindow;

/*beallitasok:*/
theWindowAttributes.border_pixel=WhitePixel(theDisplay,theScreen);
theWindowAttributes.background_pixel=BlackPixel(theDisplay,theScreen);
theWindowAttributes.override_redirect=False;
theWindowAttributes.event_mask=ExposureMask | KeyPressMask;
/*Ha False:a windowmanager azt csinal vele, amit akar*/
theWindowMask=CWBackPixel|CWBorderPixel|CWOverrideRedirect|CWEventMask;

/*Most jon az ablak megnyitasa:*/
theNewWindow=XCreateWindow(theDisplay,
RootWindow(theDisplay,theScreen),/*=theParentWindow ennel az ablaknal*/
x,y,width,height,BORDER_WIDTH,theDepth,
InputOutput,/*Inputonly:atlatszo*/
CopyFromParent,theWindowMask,
&theWindowAttributes);

/* mybackground = BlackPixel(theDisplay,theScreen);
   myforeground = WhitePixel(theDisplay,theScreen);
theNewWindow=XCreateSimpleWindow(theDisplay,DefaultRootWindow(theDisplay),
0,0,width,height,5,myforeground,mybackground);*/

/*Most mondom meg a window-managernek a meretet es a helyet:*/
theSizeHints.flags=PPosition|PSize;/*igy a program allitja be*/
/*ha USPosition es USSize: a user allitja be*/
theSizeHints.x=x;
theSizeHints.y=y;
theSizeHints.width=width;
theSizeHints.height=height;

XSetNormalHints( theDisplay,theNewWindow,&theSizeHints );

/*Most csinal GC-t(graphics context)*/
if (createGC( theNewWindow,theNewGC ) == 0 )
{
XDestroyWindow(theDisplay,theNewWindow); return( (Window) 0 );
}
/*Most teszi le az ablakot:*/
XMapWindow(theDisplay,theNewWindow);

/*ha  nem interaktiv a program a windowmanager altal kuldott puffer (pl.
a user egermozgatasai) tartalmat kidobja:*/
XFlush( theDisplay );

/*Window id-et visszaadja*/
return( theNewWindow );
}
createGC( theNewWindow,theNewGC )
Window theNewWindow;
GC     *theNewGC;
{
XGCValues theGCValues;
*theNewGC=XCreateGC(theDisplay,theNewWindow,(unsigned long) 0,&theGCValues);
/* *theNewGC=XCreateGC(theDisplay,theNewWindow,0,0);*/
if ( *theNewGC == 0 ) /* unable to create a GC */
{ return(0); }
else
{
XSetForeground(theDisplay,*theNewGC,theBlackPixel);
XSetBackground(theDisplay,*theNewGC,theWhitePixel);  
return(1);
}
}